from typing import Literal

from pydantic import BaseModel


class Argument(BaseModel):
    type: Literal['str', 'int', 'float']
    description: str | None = None


class ModelDescription(BaseModel):
    engine: str
    name: str
    arguments: dict[str, Argument]
    description: None | str = None
